
/* Sample ARexx User-defined requester  */

if ~show('l', "rexxsupport.library") then
    addlib('rexxsupport.library',0,-30,0)

options results

portname = 'OURPORTNAME'
shutdown = 0
if openport(portname) then do

window allocate     /* request a new window object */
win = result        /* store window object # in 'win' */
window win gadget 1 10 165 100 0 ok 0 "Use" "use"
window win gadget 0 126 165 100 0 reset 0 "Reset" "reset"
window win gadget 0 242 165 100 0 cancel 0 "Cancel" "cancel"
window win gadget 12 80 10 250 10 string 0 "String" "string" '"default string"'
window win gadget 13 240 120 20 20 checkmark 1 '"Checkmark"' "checkmark" 1
window win gadget 0 220 40 130 64 border 2 '"Radio Gadgets"'
window win gadget 256 230 52 0 0 radio 0 '"1. Radio 1"' "radio1" 1
window win gadget 257 230 65 0 0 radio 0 '"2. Radio 2"' "radio2"
window win gadget 258 230 78 0 0 radio 0 '"3. Radio 3"' "radio3"
window win gadget 259 230 91 0 0 radio 0 '"4. Radio 4"' "radio4"
window win gadget 512 10 40 180 90 list 255 '"List Gadget"' "list" 5
window win list 512 '"Red"' '"Blue"' '"Green"' '"Black"' '"White"'
window win list 512 '"Yellow"' '"Voilet"' '"Pink"' '"Purple"'
window win list 512 '"Grey"' '"Flesh"' '"Orange"' '"Magneta"'
window win list 512 '"Cyan"' '"Transparent"'
window win gadget 14 60 140 250 10 proph 0 '"Prop"' "prop" 3 1 7
window win open 365 200 '"Test Requester..."' async portname notify string button radio prop checkmark list reset
woi = result

if woi ~= null() then do
  do until shutdown

    call waitpkt(portname)
    msg = getpkt(portname)

    if msg ~= '0000 0000'x then do
      cmd = getarg(msg)

      say 'We got: ' cmd 

      if upper(cmd)='OK' then
        shutdown = 1

      if upper(cmd)='USE' then
        shutdown = 1

      if upper(cmd)='CANCEL' then
        shutdown = 1

      call reply(msg,0)
      end
    end
  end

call closeport(portname)
window win free             /* free all window resources */
end
