/* FinalCalc script to scan though the graphs list and 
   builds a print job for each one. */

options results
shutdown = 0
count = 0


REQUEST '"This script will generate a print job for every graph in the current project."' '"Go Ahead."' '"Forget It!"'

returned = result

if returned = 1 then do
    graph first
    graphname = result;

    do until shutdown

       job '"'graphname'"' exists

       if rc = 130 then do
           count = count+1
    
           job '"'graphname'"' new
           job '"'graphname'"' graph '"'graphname'"'
           job '"'graphname'"' sideways on
           job '"'graphname'"' header_left '"Graph: %j"'
           job '"'graphname'"' header_right '"%d"'
           job '"'graphname'"' defsize on
           end

        graph next
        graphname = result

        if graphname='' then
            shutdown = 1

        end

    if count > 0 then do
        text = "Generated" count "graph print jobs."
        request '"'text'"'
        end
    else
        request '"No graphs found."'
    end

exit
