/* FinalCalc script to scan though the print job list and 
   change the paper size to default */

options results
shutdown = 0
count = 0

do until shutdown
    if count = 0 then job first
    else         job next

    jobname = result;

    if jobname='' then
        shutdown = 1
    else do
         /* Here we do whatever we want to the print job.. */
         /* Note that we put double-quotes around the job */
         /* name to protect it in case it has spaces. */

        job '"'jobname'"' defsize on
        count = count+1
    end
end

if count > 0 then do
    text = "Changed" count "print jobs to default paper size."
    request '"'text'"'
    end
else
    request '"No print jobs found."'

exit
